From 6f61ffc7368d958f0c9092089e90e9b467e5fd5e Mon Sep 17 00:00:00 2001
From: Jeffy Chen <jeffy.chen@rock-chips.com>
Date: Fri, 2 Apr 2021 01:50:22 +0800
Subject: [PATCH 44/98] desktop-shell: Resize views when work area changed

Signed-off-by: Jeffy Chen <jeffy.chen@rock-chips.com>
---
 desktop-shell/shell.c | 11 +++++++++++
 1 file changed, 11 insertions(+)

diff --git a/desktop-shell/shell.c b/desktop-shell/shell.c
index 36fb921..dc00bba 100644
--- a/desktop-shell/shell.c
+++ b/desktop-shell/shell.c
@@ -48,6 +48,9 @@
 #define DEFAULT_NUM_WORKSPACES 1
 #define DEFAULT_WORKSPACE_CHANGE_ANIMATION_LENGTH 200
 
+static void
+handle_output_resized_shsurfs(struct desktop_shell *shell);
+
 struct focus_state {
 	struct desktop_shell *shell;
 	struct weston_seat *seat;
@@ -2880,6 +2883,7 @@ panel_committed(struct weston_surface *es,
 	struct weston_output *output = sh_output->output;
 	struct weston_coord_global pos = output->pos;
 	struct desktop_shell *shell = sh_output->shell;
+	pixman_rectangle32_t old_area, new_area;
 
 	if (!weston_surface_has_content(es))
 		return;
@@ -2902,18 +2906,25 @@ panel_committed(struct weston_surface *es,
 		break;
 	}
 
+	get_output_work_area(shell, output, &old_area);
 	if (!weston_surface_is_mapped(es)) {
 		weston_surface_map(es);
 		assert(wl_list_empty(&es->views));
 		sh_output->panel_view = weston_view_create(es);
 		weston_view_set_output(sh_output->panel_view, es->output);
 	}
+	get_output_work_area(shell, output, &new_area);
 
 	assert(sh_output->panel_view);
 	pos = weston_coord_global_add(output->pos, sh_output->panel_offset);
 	weston_view_set_position(sh_output->panel_view, pos);
 	weston_view_move_to_layer(sh_output->panel_view,
 				  &shell->panel_layer.view_list);
+
+	if (old_area.x != new_area.x || old_area.y != new_area.y ||
+	    old_area.width != new_area.width ||
+	    old_area.height != new_area.height)
+		handle_output_resized_shsurfs(shell);
 }
 
 static void
-- 
2.20.1

